package
{
	import flash.display.BlendMode;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.TiledImage;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import flash.utils.ByteArray;
	import flash.display.BitmapData;
	
	public class DynamicTilemap extends Entity
	{
		public var collision:Grid = null;
		public var map:Vector.<uint>;
		public var w:uint, h:uint,tw:uint,th:uint;
		public var tiles:Spritemap;
		public static var player:Player = null;
		public function DynamicTilemap(w:uint, h:uint)
		{
			this.w = w;
			this.h = h;
			map = new Vector.<uint>(w * h, true);
			type = "level";
			
		}
		
		// TODO: add entity-idx pairs for automated object creation
		public function load(img:Class, map:Class,tile_w:uint,tile_h:uint):void
		{
			tw = tile_w;
			th = tile_h;
			tiles = new Spritemap(img, tw, th);
			//tiles.blend = BlendMode.LIGHTEN
			tiles.alpha = .8;
			collision = new Grid(w*tw, h*th, tw, th, 0, 0);
			mask = collision;
			var b:ByteArray = new map();
			var maxTile:uint = 0;
			for (var yy:uint = 0; yy < h; yy ++)
			{
				for (var xx:uint = 0; xx < w; xx ++)
				{
					var tile:uint = b.readUnsignedByte();
					//////////////////////////
					// Checking for stuff that isn't just plain tiles
					// everything from $80 to $c0 is animated
					// everything from $c0 is a game object (non-tile)
					if ((tile & 0xc0) == 0xc0)
					{
						if (tile == 0xc0)
						{
							player = new Player(xx * tw, yy * th);
							FP.world.add(player);
						}
					} else if (tile == 76)
					{
						
							FP.world.add(new Ai(xx*tw,yy*th));
						
					} else {
						set_at(xx, yy, tile);
						if (tile > maxTile) maxTile = tile;
					}
					
				}
			}
			for (var c:uint = 0; c <= maxTile; c++)
			{
				//tiles.add(c.toString(), [c], 0, false);
			}
			
			
		}
		
		public function get_at(x:uint, y:uint):uint
		{
			if (x < 0 || y < 0 || x > w - 1 || y > h - 1) return 0;
			return map[x+y*w]
		}
		
		public function set_at(x:uint, y:uint,value:uint):void
		{
			if (x < 0 || y < 0 || x > w - 1 || y > h - 1) return;
			map[x + y * w] = value;
			collision.setTile(x, y, value!=0);
		}
		
		override public function update():void
		{
			
		}
		
		override public function render():void
		{
			var sx:int, sy:int, ex:int, ey:int;
			sx = (FP.camera.x / tw) - 1;
			sy = (FP.camera.y / th) - 1;
			ex = sx + (FP.width / tw) + 2;
			ey = sy + (FP.height / th) + 3;
			// trace("rendering from [ " + sx + " " + sy + " ] to [ " + ex + " " + ey + " ]");
			if (sx < 0) sx = 0;
			if (sy < 0) sy = 0;
			if (ex > w-1) ex = w-1;
			if (ey > h-1) ex = h-1;
			if (sx > w || sy > h || ex < 0 || ey < 0) return;
			for (var xx:uint = sx; xx < tw; xx++)
			{
				for (var yy:uint = sy; yy < ey; yy++)
				{
					var tile:uint = get_at(xx, yy);
					if (!tile) continue;
					var point:Point = new Point(xx * tw + x, yy * th + y);
					tiles.frame = tile;
					tiles.render(FP.buffer, point, FP.camera);
				}
			}
		}
	}
}